<h4><%= t(Tools::DecisionMat.model_name.human(:count=>2)) %>
<%= link_to fa_icon_add('icon-orange icon-margin') + t('.new') ,
            new_tools_decision_mat_path(tools_decision_mat: { rca_id: @rca.id,
                                                              tool_reference: @step_tool.tool_reference,
                                                              tool_num: @step_tool.tool_num,
                                                              entry_class: @step_tool.tool_options[:entry_class] }),
            class: 'btn btn-outline-warning',
            style: 'float: right;',
            remote: true %>
</h4>
<br>
<% @tools_decision_mats.each do |tools_decision_mat| %>
  <% @tools_decision_mat = tools_decision_mat %>
  <%= render partial: 'open' %>
<% end %>

<script text='javascript'>
  $(function(){
    // let nbvals = 0;
    let weights = {};
    let thresholds = {};
    let max_values = {};
    $('.dec-mat-weights').each(function(){
      weights[$(this).attr('crit-id')] = parseInt($(this).html());
      // nbvals += 1;
    });
    $('.dec-mat-thresholds').each(function(){
      thresholds[$(this).attr('crit-id')] = parseInt($(this).html());
      // nbvals += 1;
    });
    $('.dec-mat-max-value').each(function(){
      max_values[$(this).attr('dec-mat-id')] = parseInt($(this).val());
    });
    console.log(thresholds);
    console.log(max_values);

    function dec_mat_calculate_line(dec_mat_id, entry) {
      // console.log(entry);
      let i = 0;
      let total = 0, subtotal = 0;
      let is_red = false;
      $('.dec-mat-val[dec-mat-entry-id="'+entry+'"]').each(function(){
        // vérifie la valeur par rapport au min et au max + seuil + set color

        let value = parseInt($(this).val());
        if (value >= max_values[dec_mat_id]) {
          $(this).val(max_values[dec_mat_id]);
          $(this).css('font-weight', 'bold');
        }
        else {
          $(this).css('color', '#000');
          $(this).css('font-weight', 'normal');
          if (value < 0) {
            $(this).val(0);
          }
          else {
            if (value < thresholds[$(this).attr('dec-mat-crit-id')]) {
              $(this).css('color', '#f00');
              $(this).css('font-weight', 'bold');
              is_red= true;
            }
            else {
              // $(this).css('color', '#000');
              // $(this).css('font-weight', 'normal');
            }

          }
        }

        // console.log('calc');
        // console.log($(this).attr('dec-mat-tot-id'));
        subtotal = ($(this).val() * weights[$(this).attr('dec-mat-crit-id')]);
        $('#'+$(this).attr('dec-mat-tot-id')).html(subtotal);

        /* if (subtotal < thresholds[$(this).attr('dec-mat-crit-id')]) {
          $('#'+$(this).attr('dec-mat-tot-id')).css('color', '#f00');
          $('#'+$(this).attr('dec-mat-tot-id')).css('font-weight', 'bold');
          is_red= true;
        }
        else {
          $('#'+$(this).attr('dec-mat-tot-id')).css('color', '#000');
          $('#'+$(this).attr('dec-mat-tot-id')).css('font-weight', 'normal');
        } */
        total += subtotal;
        i += 1;
      })
      // console.log(total);
      $('.mat-total[dec-mat-entry-id="'+entry+'"]').html(total);
      if (is_red) {
        $('.mat-total[dec-mat-entry-id="'+entry+'"]').attr('is_red', 'true');
      }
      else {
        $('.mat-total[dec-mat-entry-id="'+entry+'"]').attr('is_red', 'false');
      }
    }

    function dec_mat_total_colors(dec_mat_id) {
      let min = 100000;
      let max = 0;
      let val;
      $('#tool-dec-mat-'+dec_mat_id).find('.mat-total').each(function(){
        val = parseInt($(this).html());
        if (val < min) { min = val; }
        if ($(this).attr('is_red') == 'false' && val > max) { max = val; }
      });
      let ecart = min+ (max-min)/2

      $('#tool-dec-mat-'+dec_mat_id).find('.mat-total').each(function(){
        val = parseInt($(this).html());

        if ($(this).attr('is_red') == 'false') {
          if (val == max) { $(this).attr('class', 'mat-total mat-total-max') }
          else if (val == min) { $(this).attr('class', 'mat-total mat-total-min') }
          else if (val > ecart) { $(this).attr('class', 'mat-total mat-total-moy') }
          else { $(this).attr('class', 'mat-total') }
        }
        else {
          $(this).attr('class', 'mat-total mat-total-min')
        }
      });
    }

    // Initialisations
    $('.dec-mat-val').each(function(){
      let entry = $(this).attr('dec-mat-entry-id');
      let dec_mat_id = $(this).attr('dec-mat-id');
      dec_mat_calculate_line(dec_mat_id, entry);
    });
    $('.dec-mat-open').each(function(){
      let dec_mat_id = $(this).attr('dec-mat-id');
      dec_mat_total_colors(dec_mat_id);
    });

    // Action sur change value
    $('.dec-mat-val').change(function(){
      let entry = $(this).attr('dec-mat-entry-id');
      let dec_mat_id = $(this).attr('dec-mat-id');

      // let max_value = parseInt($('#max-value-'+dec_mat_id).val());

      // if (parseInt($(this).val()) >= max_value) {
      //   $(this).val(max_value);
      //   $(this).css('font-weight', 'bold');
      // }
      // else {
      //   $(this).css('font-weight', 'normal');
      //   if (parseInt($(this).val()) < 0) {
      //     $(this).val(0);
      //   }
      // }

      dec_mat_calculate_line(dec_mat_id, entry);

      dec_mat_total_colors(dec_mat_id);

      // change la couleur du bouton submit
      $('#dec-mat-submit-'+dec_mat_id).attr('class', 'btn btn-warning');
    });

    $('.dec-mat-radio').change(function(){
      let dec_mat_id = $(this).attr('dec-mat-id');
      // change la couleur du bouton submit
      $('#dec-mat-submit-'+dec_mat_id).attr('class', 'btn btn-warning');
    });

    // Collapse storage
//     function storeDivCollapsedState(div_name, div_header) {
//       // when the div is shown, save a localStorage with a value of 'true'
//       $("#" + div_name).on('shown.bs.collapse', function () {
//         $('#'+div_header).html('<%= fa_icon('caret-up') %>');
//         // localStorage.setItem(div_name, "true");
//         localStorage.removeItem(div_name);
//       });
//       // when the div is collapsed, remove the same localStorage
//       $("#" + div_name).on('hidden.bs.collapse', function () {
//         $('#'+div_header).html('<%= fa_icon('caret-down') %>');
//         // localStorage.removeItem(div_name);
//         localStorage.setItem(div_name, "false");
//       });
//
//       // on page load, show or hide the div (and stylized the header) according to the localStorage (if it exists)
//       var showDiv = localStorage.getItem(div_name);
//       // console.log(div_name+"==============================>");
//       // console.log(showDiv);
//       // console.log(localStorage);
//       if (showDiv == null) {
//           $("#" + div_name).addClass("show");           // The div to show
//           $("#" + div_header).removeClass("collapsed"); // The header to stylize as expanded
//           // $('#'+div_header).html('= fa_icon('caret-up') %>');
//           $('#'+div_header).find('i').addClass('fa-caret-up');
//           $('#'+div_header).find('i').removeClass('fa-caret-down');
//
//       }
//     };
//     $('.tdm-collapse').each(function(){
//       storeDivCollapsedState($(this).attr('id'), "header-" + $(this).attr('id'));
//     })
  });
</script>
